#if defined(__STDC__) || defined(__cplusplus)
#define YYCONST const
#define YYPARAMS(x) x
#define YYDEFUN(name, arglist, args) name(args)
#define YYAND ,
#define YYPTR void *
#else
#define YYCONST
#define YYPARAMS(x) ()
#define YYDEFUN(name, arglist, args) name arglist args;
#define YYAND ;
#define YYPTR char *
#endif
#ifndef lint
YYCONST static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley +Cygnus.28) 01/20/91";
#endif
#define YYBYACC 1
#ifndef YYDONT_INCLUDE_STDIO
#include <stdio.h>
#endif
#ifdef __cplusplus
#include <stdlib.h> /* for malloc/realloc/free */
#endif

/*----------------------------------------------------------------------------
// Copyright (c) 1994,1995 Southeastern Universities Research Association,
//                         Continuous Electron Beam Accelerator Facility
//
// This software was developed under a United States Government license
// described in the NOTICE file included as part of this distribution.
//----------------------------------------------------------------------------
//
// Description:    
//   Parser rsvc logic expression
//                                                  
// Author:  Jie Chen  
//       
// Revision History:
//   rsvc_logic.y,v
// Revision 1.2  1998/01/23  13:50:10  akers
// Ongoing development
//
 * Revision 1.1  1998/01/22  17:08:28  akers
 * Addition of new NameServer
 *
//                                       
//---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifndef _WIN32
#include <unistd.h>
#endif

#include <fcntl.h>
#include <rsvcLogic.h>

#ifdef __VMS
/* VMS does not have unlink but it does have the function remove().
   Note that remove() may not be able to delete directory files . */
#define unlink(tmp) (remove((tmp)))
#endif

typedef union {
  rsvc_logic_data* data;
  rsvcLogicInst*   inst;
} YYSTYPE;
#define TAGNAME 257
#define CSTRING 258
#define DVALUE 259
#define IVALUE 260
#define EQUAL 261
#define LESS 262
#define GREATER 263
#define NOTEQUAL 264
#define LESSOREQUAL 265
#define GREATEROREQUAL 266
#define LEFTP 267
#define RIGHTP 268
#define OR 269
#define AND 270
#define LIKE 271
#define NOT 272
#define CERROR 273
#define YYERRCODE 256
static YYCONST short yylhs[] = {                                        -1,
    0,    2,    2,    2,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,
};
static YYCONST short yylen[] = {                                         2,
    1,    1,    3,    3,    2,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,
};
static YYCONST short yydefred[] = {                                      0,
    0,    0,    0,    0,    2,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    5,    0,    0,    9,    8,    7,
   11,   10,   13,   12,   20,   19,   18,   15,   14,   17,
   16,   21,    6,    0,    3,
};
static YYCONST short yydgoto[] = {                                       4,
    5,    6,
};
static YYCONST short yysindex[] = {                                   -257,
 -241, -257, -257,    0,    0, -267, -252, -243, -228, -247,
 -226, -224, -249, -242,    0, -257, -257,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -256,    0,
};
static YYCONST short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,   29,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    1,    0,
};
static YYCONST short yygindex[] = {                                      0,
    0,    2,
};
#define YYTABLESIZE 270
static YYCONST short yytable[] = {                                       1,
    4,   16,   17,   14,   15,   18,   19,   20,   32,    2,
   25,   26,   27,   17,    3,   21,   22,   34,   35,    7,
    8,    9,   10,   11,   12,   33,   16,   17,    1,   13,
   23,   24,   28,   29,   30,   31,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    4,    4,
};
static YYCONST short yycheck[] = {                                     257,
    0,  269,  270,    2,    3,  258,  259,  260,  258,  267,
  258,  259,  260,  270,  272,  259,  260,   16,   17,  261,
  262,  263,  264,  265,  266,  268,  269,  270,    0,  271,
  259,  260,  259,  260,  259,  260,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,
};
#define YYFINAL 4
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 273
#if YYDEBUG
static YYCONST char *YYCONST yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TAGNAME","CSTRING","DVALUE",
"IVALUE","EQUAL","LESS","GREATER","NOTEQUAL","LESSOREQUAL","GREATEROREQUAL",
"LEFTP","RIGHTP","OR","AND","LIKE","NOT","CERROR",
};
static YYCONST char *YYCONST yyrule[] = {
"$accept : rsvc_logic_parse",
"rsvc_logic_parse : rsvc_logic",
"rsvc_logic : logic_exp",
"rsvc_logic : rsvc_logic AND rsvc_logic",
"rsvc_logic : rsvc_logic OR rsvc_logic",
"rsvc_logic : NOT rsvc_logic",
"rsvc_logic : LEFTP rsvc_logic RIGHTP",
"logic_exp : TAGNAME EQUAL IVALUE",
"logic_exp : TAGNAME EQUAL DVALUE",
"logic_exp : TAGNAME EQUAL CSTRING",
"logic_exp : TAGNAME LESS IVALUE",
"logic_exp : TAGNAME LESS DVALUE",
"logic_exp : TAGNAME GREATER IVALUE",
"logic_exp : TAGNAME GREATER DVALUE",
"logic_exp : TAGNAME LESSOREQUAL IVALUE",
"logic_exp : TAGNAME LESSOREQUAL DVALUE",
"logic_exp : TAGNAME GREATEROREQUAL IVALUE",
"logic_exp : TAGNAME GREATEROREQUAL DVALUE",
"logic_exp : TAGNAME NOTEQUAL IVALUE",
"logic_exp : TAGNAME NOTEQUAL DVALUE",
"logic_exp : TAGNAME NOTEQUAL CSTRING",
"logic_exp : TAGNAME LIKE CSTRING",
};
#endif
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#ifndef YYINITDEPTH
#define YYINITDEPTH 200
#endif
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
#ifndef YYMAXSTACKSIZE
#define YYMAXSTACKSIZE 10000
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
YYSTYPE yyval;
YYSTYPE yylval;
static short *yyss;
static YYSTYPE *yyvs;
static int yystacksize;
#define yyfree(x) free(x)
extern int yylex();

static YYPTR
YYDEFUN (yymalloc, (bytes), unsigned bytes)
{
    YYPTR ptr = (YYPTR) malloc (bytes);
    if (ptr != 0) return (ptr);
    yyerror ("yyparse: memory exhausted");
    return (0);
}

static YYPTR
YYDEFUN (yyrealloc, (old, bytes), YYPTR old YYAND unsigned bytes)
{
    YYPTR ptr = (YYPTR) realloc (old, bytes);
    if (ptr != 0) return (ptr);
    yyerror ("yyparse: memory exhausted");
    return (0);
}

static int
#ifdef __GNUC__
__inline__
#endif
yygrow ()
{
    int old_stacksize = yystacksize;
    short *new_yyss;
    YYSTYPE *new_yyvs;

    if (yystacksize == YYMAXSTACKSIZE)
        return (1);
    yystacksize += (yystacksize + 1 ) / 2;
    if (yystacksize > YYMAXSTACKSIZE)
        yystacksize = YYMAXSTACKSIZE;
#if YYDEBUG
    if (yydebug)
        printf("yydebug: growing stack size from %d to %d\n",
               old_stacksize, yystacksize);
#endif
    new_yyss = (short *) yyrealloc ((char *)yyss, yystacksize * sizeof (short));
    if (new_yyss == 0)
        return (1);
    new_yyvs = (YYSTYPE *) yyrealloc ((char *)yyvs, yystacksize * sizeof (YYSTYPE));
    if (new_yyvs == 0)
    {
        yyfree (new_yyss);
        return (1);
    }
    yyss = new_yyss;
    yyvs = new_yyvs;
    return (0);
}
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#if YYDEBUG
#ifdef __cplusplus
extern "C" char *getenv();
#else
extern char *getenv();
#endif
#endif

int
yyparse()
{
    register int yym, yyn, yystate;
    register YYSTYPE *yyvsp;
    register short *yyssp;
    short *yysse;
#if YYDEBUG
    register YYCONST char *yys;

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == 0)
    {
        yyss = (short *) yymalloc (YYSTACKSIZE * sizeof (short));
        if (yyss == 0)
          goto yyabort;
        yyvs = (YYSTYPE *) yymalloc (YYSTACKSIZE * sizeof (YYSTYPE));
        if (yyvs == 0)
        {
            yyfree (yyss);
            goto yyabort;
        }
        yystacksize = YYSTACKSIZE;
    }
    yysse = yyss + yystacksize - 1;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;
    goto yyloop;

yypush_lex:
    yyval = yylval;
    yystate = yytable[yyn];
yypush:
    if (yyssp >= yysse)
    {
        int depth = yyssp - yyss;
        if (yygrow() != 0)
             goto yyoverflow;
        yysse = yyss + yystacksize -1;
        yyssp = depth + yyss;
        yyvsp = depth + yyvs;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    yyn = yysindex[yystate];
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if (yyn != 0
        && ((yyn += yychar), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyerrflag > 0)  --yyerrflag;
        yychar = (-1);
        goto yypush_lex;
    }
    yyn = yyrindex[yystate];
    if (yyn != 0
        && ((yyn += yychar), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            yyn = yysindex[*yyssp];
            if (yyn != 0
                && ((yyn += YYERRCODE), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
                && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                goto yypush_lex;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
{logic_code (rsvc_logic_end);
                                logic_code (RSVC_LOGIC_STOP);
                               }
break;
case 2:
{ }
break;
case 3:
{logic_code (rsvc_logic_and);}
break;
case 4:
{logic_code (rsvc_logic_or);}
break;
case 5:
{logic_code (rsvc_logic_neg);}
break;
case 6:
{}
break;
case 7:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_equal_int);
                                 }
break;
case 8:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_equal_dbl);
                                }
break;
case 9:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_equal_str);
                                }
break;
case 10:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_less_int);
                                 }
break;
case 11:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_less_dbl);
                                }
break;
case 12:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_greater_int);
                                }
break;
case 13:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_greater_dbl);
                                 }
break;
case 14:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_lesseq_int);
                                 }
break;
case 15:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_lesseq_dbl);
                                 }
break;
case 16:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_greatereq_int);
                                 }
break;
case 17:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_greatereq_dbl);
                                 }
break;
case 18:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_noequal_int);
                                }
break;
case 19:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_noequal_dbl);
                               }
break;
case 20:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_noequal_str);
                                }
break;
case 21:
{logic_code (logic_val_push);
                                 logic_code ((rsvcLogicInst)yyvsp[-2].data);
                                 logic_code ((rsvcLogicInst)yyvsp[0].data);
				 logic_code (rsvc_data_has_str);
                               }
break;
    }
    yyssp -= yym;
    yyvsp -= yym;
    yym = yylhs[yyn];
    yystate = *yyssp;
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    yyn = yygindex[yym];
	 if (yyn != 0
        && ((yyn += yystate), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    goto yypush;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
